/*
 * Copyright 2008 Cpsula Inovao em TI
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package com.capsula.gwt.reversegeocoder.client;


import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.maps.client.geom.LatLng;

public class ReverseGeocoder {

	private ReverseGeocoder() {}

	public static void reverseGeocode(LatLng point, ReverseGeocoderCallback callback) {
		JavaScriptObject jsoPeer = ReverseGeocoderImpl.impl.construct();
		
		if (callback != null) {
			addLoadListener(jsoPeer, callback);
		}
		
		ReverseGeocoderImpl.impl.reverseGeocode(jsoPeer, point);
	}

	private static void addLoadListener(final JavaScriptObject jsoPeer,
			final ReverseGeocoderCallback callback) {

		GEvent.impl.addListener(jsoPeer, "load", new JSPlacemarkCallback() {
			@Override
			public void callback(ExtendedPlacemark placemark) {
				callback.onSuccess(placemark);
			}
		});

		GEvent.impl.addListener(jsoPeer, "error", new JSLatLngCallback() {
			@Override
			public void callback(LatLng point) {
				callback.onFailure(point);
			}
		});
	}

}
